clear;
clc;
load('.\data\demo_data');   
% data description:
% Gallery.X: gallery data with each element being one image set represented by
%            a matrix, where each column corresponds to one image instance.
% Gallery.y: the label of gallery data
% Probe.X: probe data with each element being one image set represented by
%          a matrix, where each column corresponds to one image instance.
% Probe.y: the label of proble data
%%
%calculate logarithm of SPD feature for image set
LogC = Compute_Log_Cov(Gallery.X);
LogC_t = Compute_Log_Cov(Probe.X);
%%
%parameter setting
params = struct();
params = SetDefaultParams(params);
params.gamma = 10; % common tuning range of [0.001 0.01 0.1 1 10 100 1000]
params.zeta = 0.1; % common tuning range of 0.1: 0.1: 1
params.prop = 2; % default setting, prop=2 means positive : negative = 1 : 2

%data constriant setting for metric learing
[upperbound, lowerbound, C, B] = GenConstraint(LogC,Gallery.y,params);

%initialization of LEML model
n = size(LogC,1);
P_0 = eye(n);
% training code of LEML model
P_leml = LEMLAlg(C, B, P_0, params);
clear B
%% calculate similarity
sim_mat = zeros(length(Gallery.y),length(Probe.y));
for i = 1 : length(Gallery.y)
    T1=LogC(:,:,i);
    for j = 1 : length(Probe.y)
        T2=LogC_t(:,:,j);
        T = T1-T2;
        T = T'*T;
        sim_mat(i,j) = trace(P_leml*T);
    end
end
%% calculate accuracy
sampleNum = length(Probe.y);
[sim ind] = sort(sim_mat,1,'ascend');
correctNum = length(find((Probe.y-Gallery.y(ind(1,:)))==0));
fRate1 = correctNum/sampleNum;
fprintf('fRate = %f \n', fRate1);

